import { useMemo } from 'react';
export const VoronoiOverlay = ({
  allData,
  innerWidth,
  innerHeight,
  lineGenerator,
  handleVornonHover,
}) => {
  return useMemo(() => {
    const points = allData.map((d) => [
      lineGenerator.x()(d),
      lineGenerator.y()(d),
    ]);
    const delaunay = d3.Delaunay.from(points);
    const voronoi = delaunay.voronoi([
      0,
      0,
      innerWidth,
      innerHeight,
    ]);
    return (
      <g className="voronoi">
        {points.map((point, i) => (
          <path
            onMouseEnter={() =>
              handleVornonHover(allData[i])
            }
            fill="none"
            stroke="pink"
            d={voronoi.renderCell(i)}
          />
        ))}
      </g>
    );
  }, [
    allData,
    lineGenerator,
    innerWidth,
    innerHeight,
    handleVornonHover,
  ]);
};
